import { CompilerPlugin, Compiler } from "./interop/webpack";
import { Options, NormalizedOptions } from "./options";
export default class CssEntryPlugin implements CompilerPlugin {
    readonly options: NormalizedOptions;
    /**
     * Creates a new instance of the CssEntryPlugin.
     * @param options The configuration options (required).
     */
    constructor(options?: Options);
    /**
     * Called once by the compiler when installing the plugin.
     * @param compiler The compiler instance.
     */
    apply(compiler: Compiler): void;
    /**
     * Enables the plugin.
     */
    enable(): void;
    /**
     * Disables the plugin.
     */
    disable(): void;
}
