import { CompilationPlugin, Compilation } from "./interop/webpack";
import { HtmlData } from "./interop/html-webpack-plugin";
export default class HtmlWebpackPluginCssEntryFix implements CompilationPlugin {
    apply(compilation: Compilation): void;
    /**
     * Called by the HtmlWebpackPlugin for other plugins to change the assetTag definitions.
     * @param htmlPluginData The html plugin data that contains the asset tags.
     * @param callback The callback to call when ready.
     * @see https://github.com/jantimon/html-webpack-plugin/blob/master/index.js
     * @see https://github.com/jantimon/html-webpack-plugin#events
     */
    onHtmlWebpackPluginAlterAssetTags(htmlData: HtmlData): Promise<HtmlData>;
}
