import Tapable, { AsyncWaterfallHandler, AsyncHandler } from "tapable";
export default Tapable;
/**
 * Transforms a promise returning function to an AsyncWaterfallHandler function.
 * @param handler The function that returns the promise.
 * @returns The AsyncWaterfallHandler function.
 */
export declare function toAsyncWaterfallHandler<T>(handler: (value: T) => Promise<T> | T): AsyncWaterfallHandler<T>;
/**
 * Transforms a promise returning function to an AsyncHandler function.
 * @param handler The function that returns the promise.
 * @returns The AsyncHandler function.
 */
export declare function toAsyncHandler(handler: () => Promise<void>): AsyncHandler;
