"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _bluebird = require("bluebird");

exports.toAsyncWaterfallHandler = toAsyncWaterfallHandler;
exports.toAsyncHandler = toAsyncHandler;

var _tapable = require("tapable");

var _tapable2 = _interopRequireDefault(_tapable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = _tapable2.default;
/**
 * Transforms a promise returning function to an AsyncWaterfallHandler function.
 * @param handler The function that returns the promise.
 * @returns The AsyncWaterfallHandler function.
 */

function toAsyncWaterfallHandler(handler) {
  return (value, callback) => (0, _bluebird.resolve)().then(() => handler(value)).then(newValue => callback(null, newValue), err => callback(err, value));
}
/**
 * Transforms a promise returning function to an AsyncHandler function.
 * @param handler The function that returns the promise.
 * @returns The AsyncHandler function.
 */
function toAsyncHandler(handler) {
  return callback => (0, _bluebird.resolve)().then(() => handler()).then(() => callback(), err => callback(err));
}